#define ARRAY_LIMIT 10000
#define CRITICAL_ERROR 500
#include <iostream>
using namespace std;

struct aBigNode
{
	int data[100];
	aBigNode *link;
};
typedef aBigNode* ABigNodePtr;

aBigNode* aBigNodePtrArray[ARRAY_LIMIT];

class AnExceptionalClass
{
public:
	AnExceptionalClass();
	AnExceptionalClass(int someErrorCount);
	int getErrorCount();
private:
	int ErrorCount;
};

void aFunction(void) throw (AnExceptionalClass);

void main()
{
	try
	{
		aFunction();
	}
	catch (AnExceptionalClass e)
	{
		cout << "Exceptional value is " << e.getErrorCount() << endl;
	}

	try
	{
	for (int i = 0; i < ARRAY_LIMIT; i++)
	aBigNodePtrArray[i] = new aBigNode;

	cout << "No exceptions here\n";
	}
	catch (bad_alloc)
	{
		cout << "Ran out of memory\n";
	}

	for (int i = 0; i < ARRAY_LIMIT; i++)
	delete aBigNodePtrArray[i];

	cout << "No exceptions occurred. Normal exit\n";
}

void aFunction(void) throw (AnExceptionalClass)
{
	//Code goes here
	//An exception condition occurs with error value CRITICAL_ERROR
	throw (AnExceptionalClass(CRITICAL_ERROR));
}

AnExceptionalClass::AnExceptionalClass()
{}
AnExceptionalClass::AnExceptionalClass(int someErrorCount) : ErrorCount(someErrorCount)
{}

int AnExceptionalClass::getErrorCount()
{
	return ErrorCount;
}